package nc.ui.gl.voucher.opmodels;

import java.awt.Container;
import java.util.Vector;
import nc.bs.framework.common.NCLocator;
import nc.itf.gl.voucher.IVoucher;
import nc.ui.gl.voucher.dlg.OffsetTypeDialog;
import nc.ui.gl.vouchermodels.AbstractOperationModel;
import nc.ui.gl.vouchertools.VoucherDataCenter;
import nc.ui.glcom.period.GlPeriodForClient;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.access.AccessorManager;
import nc.vo.gl.cashflowcase.CashflowcaseVO;
import nc.vo.gl.diffanaly.DiffAnalyzeVO;
import nc.vo.gl.pubvoucher.DetailVO;
import nc.vo.gl.pubvoucher.VoucherVO;
import nc.vo.glcom.glperiod.GlPeriodVO;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDouble;

public class OffsetOperationModel extends AbstractOperationModel {

   public static VoucherVO blueOffset(VoucherVO voucher) {
      VoucherVO newVO = (VoucherVO)voucher.clone();
      newVO.setPk_voucher((String)null);
      newVO.setPk_sourcepk((String)null);
      newVO.setPk_prepared(ClientEnvironment.getInstance().getUser().getPrimaryKey());
      newVO.setPk_casher((String)null);
      newVO.setPk_checked((String)null);
      newVO.setPk_manager((String)null);
      newVO.setCashername((String)null);
      newVO.setCheckedname((String)null);
      newVO.setManagername((String)null);
      newVO.setDetailmodflag(new UFBoolean(false));
      newVO.setNo(new Integer(0));
      newVO.setIsmatched(new Boolean(false));
      newVO.setConvertflag(new UFBoolean(false));
      newVO.setOffervoucher(voucher.getPk_voucher());
      if(newVO.getVoucherkind() != null && newVO.getVoucherkind().intValue() != 1) {
         newVO.setPrepareddate(ClientEnvironment.getInstance().getDate());

         try {
            GlPeriodVO i = (new GlPeriodForClient()).getPeriod(newVO.getPk_glorgbook(), newVO.getPrepareddate());
            if(i != null) {
               newVO.setYear(i.getYear());
               newVO.setPeriod(i.getMonth());
            } else {
               newVO.setYear(VoucherDataCenter.getClientYear());
               newVO.setPeriod(VoucherDataCenter.getClientPeriod());
            }
         } catch (Exception var14) {
            newVO.setYear(VoucherDataCenter.getClientYear());
            newVO.setPeriod(VoucherDataCenter.getClientPeriod());
         }
      }

      newVO.setExplanation(getOffsetExplanation(voucher, voucher.getExplanation()));

      for(int var15 = 0; var15 < newVO.getNumDetails(); ++var15) {
         if(newVO.getDetail(var15).getDetailindex() != null) {
            String pk_detail = newVO.getDetail(var15).getPk_detail();
            newVO.getDetail(var15).setPk_detail((String)null);
            UFDouble tmpDebitquantity = newVO.getDetail(var15).getDebitquantity();
            UFDouble tmpDebitamount = newVO.getDetail(var15).getDebitamount();
            UFDouble tmpFracdebitamount = newVO.getDetail(var15).getFracdebitamount();
            UFDouble tmpLocaldebitamount = newVO.getDetail(var15).getLocaldebitamount();
            newVO.getDetail(var15).setDebitquantity(newVO.getDetail(var15).getCreditquantity());
            newVO.getDetail(var15).setDebitamount(newVO.getDetail(var15).getCreditamount());
            newVO.getDetail(var15).setFracdebitamount(newVO.getDetail(var15).getFraccreditamount());
            newVO.getDetail(var15).setLocaldebitamount(newVO.getDetail(var15).getLocalcreditamount());
            newVO.getDetail(var15).setCreditquantity(tmpDebitquantity);
            newVO.getDetail(var15).setCreditamount(tmpDebitamount);
            newVO.getDetail(var15).setFraccreditamount(tmpFracdebitamount);
            newVO.getDetail(var15).setLocalcreditamount(tmpLocaldebitamount);
            newVO.getDetail(var15).setIsmatched(new UFBoolean(false));
            newVO.getDetail(var15).setExplanation(getOffsetExplanation(voucher, voucher.getDetail(var15).getExplanation()));
            newVO.getDetail(var15).setUserData((Object)null);
            newVO.getDetail(var15).setOtheruserdata((Vector)null);
            newVO.getDetail(var15).setIsmatched(new UFBoolean(true));
            newVO.getDetail(var15).setPk_offerdetail(pk_detail);
            DiffAnalyzeVO[] diffs = newVO.getDetail(var15).getDiffanalys();
            if(diffs != null && diffs.length > 0) {
               DiffAnalyzeVO[] var9 = diffs;
               int var10 = diffs.length;

               for(int var11 = 0; var11 < var10; ++var11) {
                  DiffAnalyzeVO diff = var9[var11];
                  String direct = diff.getDirect();
                  if(direct.equals("借")) {
                     diff.setDirect("贷");
                  } else {
                     diff.setDirect("借");
                  }
               }
            }

            reverseCashflow(newVO.getDetail(var15));
         }
      }

      return newVO;
   }

   private static void reverseCashflow(DetailVO detail) {
      CashflowcaseVO[] cfcases = detail.getCashFlow();
      if(cfcases != null) {
         CashflowcaseVO[] var2 = cfcases;
         int var3 = cfcases.length;

         for(int var4 = 0; var4 < var3; ++var4) {
            CashflowcaseVO cfvo = var2[var4];
            if(cfvo.getMoney() != null) {
               cfvo.setMoney((new UFDouble(0)).sub(cfvo.getMoney()));
            }

            if(cfvo.getMoneyass() != null) {
               cfvo.setMoneyass((new UFDouble(0)).sub(cfvo.getMoneyass()));
            }

            if(cfvo.getMoneymain() != null) {
               cfvo.setMoneymain((new UFDouble(0)).sub(cfvo.getMoneymain()));
            }
         }
      }

   }

   public Object doOperation() {
      Boolean isInSum = (Boolean)this.getMasterModel().getParameter("isInSumMode");
      if(isInSum != null && isInSum.booleanValue()) {
         return null;
      } else {
         VoucherVO voucher = (VoucherVO)this.getMasterModel().getParameter("vouchervo");
         if(voucher.getVoucherkind().intValue() == 223) {
            MessageDialog.showErrorDlg((Container)this.getMasterModel().getUI(), "", "期初流量凭证不能进行冲销！");
            return null;
         } else if(voucher.getPk_manager() == null) {
            MessageDialog.showErrorDlg((Container)this.getMasterModel().getUI(), "", NCLangRes.getInstance().getStrByID("20021005", "UPP20021005-000121"));
            return null;
         } else {
            IVoucher ivoucher = (IVoucher)NCLocator.getInstance().lookup(IVoucher.class.getName());

            try {
               boolean dlg = ivoucher.isOfferSetVoucher(voucher.getPk_voucher());
               if(dlg) {
                  MessageDialog.showErrorDlg((Container)this.getMasterModel().getUI(), "", NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000357"));
                  return null;
               }
            } catch (BusinessException var7) {
               var7.printStackTrace();
            }

            OffsetTypeDialog dlg1 = new OffsetTypeDialog((Container)this.getMasterModel().getUI());
            if(dlg1.showModal() == 2) {
               return null;
            } else {
               int offsetType = dlg1.getOffsetType();
               if(offsetType == 1) {
                  voucher = redOffset(voucher);
               } else if(offsetType == 2) {
                  voucher = blueOffset(voucher);
               } else if(offsetType == 0) {
                  if(voucher.getYear().compareTo(VoucherDataCenter.getClientYear()) < 0) {
                     voucher = blueOffset(voucher);
                  } else {
                     voucher = redOffset(voucher);
                  }
               } else if(voucher.getYear().compareTo(VoucherDataCenter.getClientYear()) < 0) {
                  voucher = blueOffset(voucher);
               } else {
                  voucher = redOffset(voucher);
               }

               voucher.setPk_system(voucher.getPk_system());
               if(voucher.getModifyflag() != null && voucher.getModifyflag().length() > 0 && voucher.getModifyflag().charAt(0) == 78) {
                  String modif = "Y" + String.copyValueOf(voucher.getModifyflag().toCharArray(), 1, voucher.getModifyflag().length() - 1);
                  voucher.setModifyflag(modif);
               }

               voucher.setVerify(false);
               this.getMasterModel().setParameter("editable", new Boolean(true));
               this.getMasterModel().setParameter("vouchervo", voucher);
               this.getMasterModel().setParameter("startediting", (Object)null);
               this.getMasterModel().setParameter("saveflag", new Boolean(false));
               return null;
            }
         }
      }
   }

   public static String getOffsetExplanation(VoucherVO voucher, String exp) {
      String explanation = NCLangRes.getInstance().getStrByID("20021005", "UPP20021005-000122") + voucher.getPrepareddate() + NCLangRes.getInstance().getStrByID("20021005", "UPP20021005-000123") + AccessorManager.getAccessor("00010000000000000035", voucher.getPk_glorgbook()).getDocByPk(voucher.getPk_vouchertype()).getName();

      String tempvalue;
      for(tempvalue = voucher.getNo() == null?"0":voucher.getNo().toString(); tempvalue.length() < 4; tempvalue = "0" + tempvalue) {
         ;
      }

      explanation = explanation + tempvalue + NCLangRes.getInstance().getStrByID("20021005", "UPP20021005-000124") + "[" + exp + "]";
      byte[] bStr = explanation.getBytes();
      if(bStr.length > 100) {
         int len = 0;
         int flag = 1;

         for(int i = 0; i < 100; ++i) {
            if(bStr[i] > 0) {
               ++len;
            } else {
               ++flag;
               flag %= 2;
               len += flag;
            }
         }

         explanation = explanation.substring(0, len) + "]";
      }

      return explanation;
   }

   public static VoucherVO redOffset(VoucherVO voucher) {
      VoucherVO newVO = (VoucherVO)voucher.clone();
      newVO.setPk_voucher((String)null);
      newVO.setPk_sourcepk((String)null);
      newVO.setPk_prepared(ClientEnvironment.getInstance().getUser().getPrimaryKey());
      newVO.setPk_casher((String)null);
      newVO.setPk_checked((String)null);
      newVO.setPk_manager((String)null);
      newVO.setCashername((String)null);
      newVO.setCheckedname((String)null);
      newVO.setManagername((String)null);
      newVO.setDetailmodflag(new UFBoolean(false));
      newVO.setNo(new Integer(0));
      newVO.setIsmatched(new Boolean(false));
      newVO.setConvertflag(new UFBoolean(false));
      newVO.setOffervoucher(voucher.getPk_voucher());
      if(newVO.getVoucherkind() != null && newVO.getVoucherkind().intValue() != 1) {
         newVO.setPrepareddate(ClientEnvironment.getInstance().getDate());

         try {
            GlPeriodVO i = (new GlPeriodForClient()).getPeriod(newVO.getPk_glorgbook(), newVO.getPrepareddate());
            if(i != null) {
               newVO.setYear(i.getYear());
               newVO.setPeriod(i.getMonth());
            } else {
               newVO.setYear(VoucherDataCenter.getClientYear());
               newVO.setPeriod(VoucherDataCenter.getClientPeriod());
            }
         } catch (Exception var10) {
            newVO.setYear(VoucherDataCenter.getClientYear());
            newVO.setPeriod(VoucherDataCenter.getClientPeriod());
         }
      }

      newVO.setExplanation(getOffsetExplanation(voucher, voucher.getExplanation()));

      for(int var11 = 0; var11 < newVO.getNumDetails(); ++var11) {
         if(newVO.getDetail(var11).getDetailindex() != null) {
            String pk_detail = newVO.getDetail(var11).getPk_detail();
            newVO.getDetail(var11).setPk_detail((String)null);
            newVO.getDetail(var11).setDebitquantity((new UFDouble(0)).sub(newVO.getDetail(var11).getDebitquantity()));
            newVO.getDetail(var11).setDebitamount((new UFDouble(0)).sub(newVO.getDetail(var11).getDebitamount()));
            newVO.getDetail(var11).setFracdebitamount((new UFDouble(0)).sub(newVO.getDetail(var11).getFracdebitamount()));
            newVO.getDetail(var11).setLocaldebitamount((new UFDouble(0)).sub(newVO.getDetail(var11).getLocaldebitamount()));
            newVO.getDetail(var11).setCreditquantity((new UFDouble(0)).sub(newVO.getDetail(var11).getCreditquantity()));
            newVO.getDetail(var11).setCreditamount((new UFDouble(0)).sub(newVO.getDetail(var11).getCreditamount()));
            newVO.getDetail(var11).setFraccreditamount((new UFDouble(0)).sub(newVO.getDetail(var11).getFraccreditamount()));
            newVO.getDetail(var11).setLocalcreditamount((new UFDouble(0)).sub(newVO.getDetail(var11).getLocalcreditamount()));
            newVO.getDetail(var11).setIsmatched(new UFBoolean(false));
            newVO.getDetail(var11).setExplanation(getOffsetExplanation(voucher, voucher.getDetail(var11).getExplanation()));
            newVO.getDetail(var11).setUserData((Object)null);
            newVO.getDetail(var11).setOtheruserdata((Vector)null);
            newVO.getDetail(var11).setIsmatched(new UFBoolean(true));
            newVO.getDetail(var11).setPk_offerdetail(pk_detail);
            DiffAnalyzeVO[] diffs = newVO.getDetail(var11).getDiffanalys();
            if(diffs != null && diffs.length > 0) {
               DiffAnalyzeVO[] var5 = diffs;
               int var6 = diffs.length;

               for(int var7 = 0; var7 < var6; ++var7) {
                  DiffAnalyzeVO diff = var5[var7];
                  UFDouble amount = diff.getAmount();
                  if(amount == null) {
                     amount = UFDouble.ZERO_DBL;
                  }

                  diff.setAmount(amount.multiply(-1.0D));
               }
            }

            reverseCashflow(newVO.getDetail(var11));
         }
      }

      return newVO;
   }
}
